#version 150

precision mediump float;

layout(points) in;
layout(triangles, max_vertices = 6) out;

uniform mat4 model;

in vec4 geomVertex[1];
in float alphapoint[1];

out float alpha;
out vec2 fragTexCoord;
out float lifetime;

void main()
{	
	alpha = alphapoint[0];
	lifetime = alphapoint[0];
	
	alpha *= alpha;
	
	if(alpha < 0.039){
		return;
	}
	
	float halfalpha = sin(alpha);
	
	vec4 pos = geomVertex[0];
	
	//triangle one
	fragTexCoord = vec2(0, 0);
	gl_Position = pos + vec4(-halfalpha, halfalpha, 0, 0);	
	EmitVertex();
	
	fragTexCoord = vec2(0, 1);
	gl_Position = pos + vec4(-halfalpha, -halfalpha, 0, 0);	
	EmitVertex();
	
	fragTexCoord = vec2(1, 1);
	gl_Position = pos + vec4(halfalpha, -halfalpha, 0, 0);	
	EmitVertex();
	
	EndPrimitive();
	
	
	//triangle two
	fragTexCoord = vec2(0, 0);
	gl_Position = pos + vec4(-halfalpha, halfalpha, 0, 0);	
	EmitVertex();
	
	fragTexCoord = vec2(1, 1);
	gl_Position = pos + vec4(halfalpha, -halfalpha, 0, 0);	
	EmitVertex();
	
	fragTexCoord = vec2(1, 0);
	gl_Position = pos + vec4(halfalpha, halfalpha, 0, 0);	
	EmitVertex();

	EndPrimitive();
}