#version 140              // delete this line if using GLSL 1.2

// uniform shader-parameters
uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;

//texture matrices
uniform mat4 tm_0;
uniform mat4 tm_1;
uniform mat4 tm_2;
uniform mat4 tm_3;
uniform mat4 tm_4;
uniform mat4 tm_5;


// vertex-shader input variables
in vec4 vertex;
in vec4 color;
in vec3 normal;
in vec2 texCoord;

// vertex-shader output variables (passed to fragment-shader)
out vec4 frag_color;
out vec3 world_normal;
out vec4 world_position;
out vec2 fragTexCoord;

out vec4 SM_tex_coord_0;
out vec4 SM_tex_coord_1;
out vec4 SM_tex_coord_2;
out vec4 SM_tex_coord_3;
out vec4 SM_tex_coord_4;
out vec4 SM_tex_coord_5;

void main()
{
	// transform normal into world space
	vec4 normal4 = vec4(normal, 0.0f);
    world_normal = (model * normal4).xyz;
    
    // transform vertex to world-space
    world_position = model * vertex;
    
    // just pass color to fragment-shader
    frag_color = color;

    // transform vertex down the pipeline
    gl_Position = perspective * view * model * vertex;
    
    // pass texCoods
    fragTexCoord = texCoord;
    
    //Shadow texture
    SM_tex_coord_0 = tm_0 * model * vertex;
    SM_tex_coord_1 = tm_1 * model * vertex;
    SM_tex_coord_2 = tm_2 * model * vertex;
    SM_tex_coord_3 = tm_3 * model * vertex;
    SM_tex_coord_4 = tm_4 * model * vertex;
    SM_tex_coord_5 = tm_5 * model * vertex;
}