#version 150

precision mediump float;

layout(points) in;
layout(triangles, max_vertices = 6) out;

uniform mat4 model;

in vec4 geomVertex[1];
in float alphapoint[1];
in vec3 geomNormal[1];

out float alpha;
out vec2 fragTexCoord;
out vec4 position;
//out vec3 normal;

void main()
{	
	//normal = geomNormal[0];
	
	alpha = alphapoint[0];
	
	float halfalpha = 3.0*sin(alpha);
	
	position = geomVertex[0];
	
	//triangle one
	fragTexCoord = vec2(0, 0);
	gl_Position = position + vec4(-halfalpha, halfalpha, 0, 0);	
	EmitVertex();
	
	fragTexCoord = vec2(0, 1);
	gl_Position = position + vec4(-halfalpha, -halfalpha, 0, 0);	
	EmitVertex();
	
	fragTexCoord = vec2(1, 1);
	gl_Position = position + vec4(halfalpha, -halfalpha, 0, 0);	
	EmitVertex();
	
	EndPrimitive();
	
	
	//triangle two
	fragTexCoord = vec2(0, 0);
	gl_Position = position + vec4(-halfalpha, halfalpha, 0, 0);	
	EmitVertex();
	
	fragTexCoord = vec2(1, 1);
	gl_Position = position + vec4(halfalpha, -halfalpha, 0, 0);	
	EmitVertex();
	
	fragTexCoord = vec2(1, 0);
	gl_Position = position + vec4(halfalpha, halfalpha, 0, 0);	
	EmitVertex();

	EndPrimitive();
}